<?php
/*
Plugin Name: افزونه درگاه پرداخت آقای پرداخت برای Easy Digital Downloads V2
Plugin URI: https://aqayepardakht.ir
Description: توسط آقای پرداخت
Version: 2.1
Author: آقای پرداخت
Author URI: https://aqayepardakht.ir
Copyright: aqayepardakht
*/

if(!defined('ABSPATH')) exit;
if(!class_exists('EDD_AQAYEPARDAKHT')):
final class EDD_AQAYEPARDAKHT
{
	public function __construct()
	{
		@session_start();
		$this->hooks();
	}

	private function hooks() 
	{
		add_filter('edd_payment_gateways', array($this, 'add_gateway'));
		add_action('edd_aqayepardakht_cc_form', array($this, 'cc_form'));
		add_action('edd_gateway_aqayepardakht', array($this, 'process'));
		add_action('init', array($this, 'verify'));
		add_filter('edd_settings_gateways', array($this, 'options'));
	}
	
	public function add_gateway($gateways) 
	{
        global $edd_options;
		$gateways['aqayepardakht'] = array(
				'admin_label'		=>	'پرداخت آنلاین - درگاه آقای پرداخت ',
				'checkout_label'	=>	$edd_options['aqayepardakht_text']
		);
		return $gateways;
	}
	
	public function cc_form()
	{
		return;
	}
	
	public function process($purchase_data) 
	{
		global $edd_options;

		$payment_data = array(
			'price' => $purchase_data['price'], 
			'date' => $purchase_data['date'],
			'user_email' => $purchase_data['post_data']['edd_email'],
			'purchase_key' => $purchase_data['purchase_key'],
			'currency' => $edd_options['currency'],
			'downloads' => $purchase_data['downloads'],
			'cart_details' => $purchase_data['cart_details'],
			'user_info' => $purchase_data['user_info'],
			'status' => 'pending'
		);
		$payment = edd_insert_payment($payment_data);

		if($payment) 
		{
			$_SESSION['aqayepardakht_payment'] = $payment;
			$_SESSION['aqayepardakht_amount'] = $purchase_data['price']/10;
			$c = $purchase_data['post_data'];
			$res = false;
			try 
			{
				$f = array(
					'amount' => $_SESSION['aqayepardakht_amount'],
					'pin' => $edd_options['aqayepardakht_pin'],
					'callback' => add_query_arg('order', 'aqayepardakht', get_permalink($edd_options['success_page'])),
					'bank' => 'mellat',
					'description' => "نام و نام خانوادگی : {$c['edd_first']} {$c['edd_last']}
	ایمیل :‌ {$c['edd_email']}
	شماره سفارش فروشگاه : {$payment}"
				);

				$f_ = '';
				foreach($f as $k=>$v) 
					$f_ .= $k . '=' . urlencode($v) . '&'; 
					
				rtrim($f_, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/create/");
				curl_setopt($ch,CURLOPT_POST, count($f));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
			}
			catch(Exception $e) 
			{
				$res = false;
			} 			
					
			if(!empty($res) AND strlen($res) > 5)
			{
				header("location: https://panel.aqayepardakht.ir/startpay/{$res}");
				exit;								
			}
			else
			{
				edd_update_payment_status($payment, 'failed');
				wp_redirect(get_permalink($edd_options['failure_page']));
				exit;					
			}	
		} 
		else 
			edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
	}
	
	public function verify() 
	{
		global $edd_options;
		if(isset($_GET['order']) == 'aqayepardakht') 
		{
			$res = false;
			try
			{
				$f = array(
					'amount' => $_SESSION['aqayepardakht_amount'],
					'pin' => $edd_options['aqayepardakht_pin'],
					'transid' => @$_POST['transid'],
				);
				
				$f_ = '';
				foreach($f as $k=>$v) 
					$f_ .= $k . '=' . urlencode($v) . '&'; 
					
				rtrim($f_, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/verify/");
				curl_setopt($ch,CURLOPT_POST, count($f));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
			}
			catch(Exception $e) 
			{
				$res = 'ارتباط با بانک برقرار نشده است .';
			}			
			
			$payment = $_SESSION['aqayepardakht_payment'];
			if(!empty($res) and $res == 1)
			{
				edd_update_payment_status( $payment, 'publish' );
				edd_empty_cart();
				edd_send_to_success_page();
			} 
			edd_update_payment_status($payment, 'failed');
			wp_redirect(get_permalink($edd_options['failure_page']));
			exit;				
		}			
	}

	public function options($settings) 
	{
         $aqayepardakht_settings = array (
			array (
				'id'	=>		'aqayepardakht_settings',
				'name'	=>		'<strong>تنظیمات درگاه آقای پرداخت </strong>',
				'desc'	=>		'تنظیمات درگاه آقای پرداخت ',
				'type'	=>		'header'
			),
			array (
				'id'	=>		'aqayepardakht_pin',
				'name'	=>		'شناسه درگاه ',
				'type'	=>		'text',
				'size'	=>		'regular'
			),
            array (
				'id'	=>		'aqayepardakht_text',
				'name'	=>		'عنوان درگاه (آقای پرداخت) ',
				'type'	=>		'text',
				'size'	=>		'regular'
			)
		);
		return array_merge($settings, $aqayepardakht_settings);
	}
}
endif;

if ( !function_exists( 'edd_rial' ) )
{
	function edd_rial( $formatted, $currency, $price ) 
	{
		return $price . ' ریال'; 
	}
	add_filter( 'edd_rial_currency_filter_after', 'edd_rial', 10, 3 );
}

new EDD_AQAYEPARDAKHT();